#include "systems.h"


#include "../game_state.h"
#include "../input.h"
#include "../pathfinding.h"

#include <math.h>
#include <raymath.h>

bool entitySetPath(const ecs_entity_t entity, const Vector2 target, Game *game) {
    const Vector2 *pPath = ecs_get(ECS, entity, Position);
    BZ_ASSERT(pPath);
    const Vector2 start = *pPath;

    Path path = {NULL, 0};
    const bool foundPath = pathfindAStar(&(PathfindingDesc) {
        .start = start,
        .target = target,
        .map = &game->map,
        .outPath = &path,
        .pool = game->pools.pathData,
        .alloc = &game->stackAlloc,
    });
    if (foundPath) {
        BZ_ASSERT(path.paths);
        ecs_set_ptr(ECS, entity, Path, &path);
        return true;
    }
    return false;
}


static Position getBottomLeftPos(Position pos, Size size) {
    return (Position) {pos.x - size.x * 0.5f, pos.y - size.y * 0.5f};
}



void entityPathRemove(ecs_iter_t *it) {
    Game *game = ecs_singleton_get_mut(ECS, Game);
    for (i32 i = 0; i < it->count; i++) {
        ecs_entity_t entity = it->entities[i];
        ecs_remove(ECS, entity, TargetPosition);
    }
}

void entityUpdateSpatialID(ecs_iter_t *it) {
    Game *game = ecs_singleton_get_mut(ECS, Game);
    Position *position = ecs_field(it, Position, 1);
    Position *size = ecs_field(it, Position, 2);
    //Velocity *velocity = ecs_field(it, Velocity, 3);
    SpatialGridID *id = ecs_field(it, SpatialGridID, 4);

    for (i32 i = 0; i < it->count; i++) {
        Position pos = getBottomLeftPos(position[i], size[i]);
        bzSpatialGridUpdate(game->entityGrid, id[i], pos.x, pos.y, size[i].x, size[i].y);
    }

}

void entityUpdateKinematic(ecs_iter_t *it) {
    Position *position = ecs_field(it, Position, 1);
    Velocity *velocity = ecs_field(it, Velocity, 2);
    Steering *steering = ecs_field(it, Steering, 3);
    Unit     *unit     = ecs_field(it, Unit, 4);

    f32 dt = it->delta_time;

    for (i32 i = 0; i < it->count; i++) {

        steering[i] = Vector2Normalize(steering[i]);
        // velocity += steering * dt
        Vector2 accel = Vector2Scale(steering[i], dt);
        accel = Vector2Scale(accel, unit->acceleration);
        velocity[i] = Vector2Add(velocity[i], accel);

        // Apply deceleration
        if (Vector2LengthSqr(steering[i]) == 0) {
            // velocity *= (1.0 - decel)
            velocity[i] = Vector2Scale(velocity[i], 1.0 - unit->deceleration);
        }

        // Reset steering
        steering[i] = Vector2Zero();

        // Check for speeding and clip
        const f32 maxSpeed = unit->maxSpeed;
        if (Vector2Length(velocity[i]) > maxSpeed) {
            velocity[i] = Vector2Normalize(velocity[i]);
            velocity[i] = Vector2Scale(velocity[i], maxSpeed);
        }

        // position += velocity * dt
        position[i] = Vector2Add(position[i], Vector2Scale(velocity[i], dt));
    }
}

void entityMoveToTarget(ecs_iter_t *it) {
    Position *position = ecs_field(it, Position, 1);
    Velocity *velocity = ecs_field(it, Velocity, 2);

    TargetPosition *targetPos = ecs_field(it, TargetPosition, 3);
    Steering       *steering  = ecs_field(it, Steering, 4);

    for (i32 i = 0; i < it->count; i++) {
        Position target = targetPos[i];
        steering[i] = Vector2Subtract(target, position[i]);
        f32 dst = Vector2LengthSqr(steering[i]);

        if (dst < 2.0f) {
            // Arrived
            ecs_remove(ECS, it->entities[i], TargetPosition);
        }
    }
}

void entityFollowPath(ecs_iter_t *it) {
    const Game *game = ecs_singleton_get(ECS, Game);

    Path *path = ecs_field(it, Path, 1);

    for (i32 i = 0; i < it->count; i++) {
        const ecs_entity_t entity = it->entities[i];

        if (!ecs_has(ECS, entity, TargetPosition)) {
            if (path[i].curWaypoint >= path[i].paths->numWaypoints) {
                path[i].curWaypoint = 0;
                PathData *oldPath = path[i].paths;
                bzObjectPoolRelease(game->pools.pathData, oldPath);
                path[i].paths = path[i].paths->next;
                if (!path[i].paths) ecs_remove(ECS, it->entities[i], Path);
            }
            if (path[i].paths) {
                TargetPosition target = path[i].paths->waypoints[path[i].curWaypoint];
                path[i].curWaypoint++;
                ecs_set_ptr(ECS, entity, TargetPosition, &target);
            }

        }
    }
}

static void entityUpdateArm(ecs_entity_t armEntity, Position pos, Velocity vel,
                            Rotation rot, Orientation orient) {
    if (!armEntity) return;
    const Arm arm = *ecs_get(ECS, armEntity, Arm);

    f32 time = fmod(GetTime() * 2.0f, 2.0f);
    if (time > 1.0f) time = 2.0f - time;

    f32 velLen = Clamp(Vector2Length(vel), 0, 4.0f) * time;
    Vector2 v = {arm.extended, velLen};
    v = Vector2Rotate(v, orient + arm.offset);
    v = Vector2Add(v, pos);
    ecs_set_ptr(ECS, armEntity, Position, &v);
}
void entityUpdateArms(ecs_iter_t *it) {
    Position *position = ecs_field(it, Position, 1);
    Velocity *velocity = ecs_field(it, Velocity, 2);
    Rotation *rotation = ecs_field(it, Rotation, 3);
    Orientation *orientation = ecs_field(it, Orientation, 4);
    Arms *arms = ecs_field(it, Arms, 5);

    for (i32 i = 0; i < it->count; i++) {
        entityUpdateArm(arms[i].primary, position[i], velocity[i],
                        rotation[i], orientation[i]);
        entityUpdateArm(arms[i].secondary, position[i], velocity[i],
                        rotation[i], orientation[i]);
    }
}

void renderColliders(ecs_iter_t *it) {
    Position *pos = ecs_field(it, Position, 1);
    Size *size = ecs_field(it, Size, 2);

    for (i32 i = 0; i < it->count; i++) {
        f32 posX = pos[i].x - size[i].x * 0.5f;
        f32 posY = pos[i].y - size[i].y * 0.5f;
        DrawRectangleLines(posX, posY, size[i].x, size[i].y, RED);
    }
}

void renderOrientationDirection(ecs_iter_t *it) {
    Position *pos = ecs_field(it, Position, 1);
    Orientation *orientation = ecs_field(it, Orientation, 2);

    for (i32 i = 0; i < it->count; i++) {
        Vector2 v = {6.0f, 0.0f};
        v = Vector2Rotate(v, orientation[i]);
        v = Vector2Add(v, pos[i]);
        DrawLine(pos[i].x, pos[i].y, v.x, v.y, RED);
    }
}

void renderArmPosition(ecs_iter_t *it) {
    Position *pos = ecs_field(it, Position, 1);
    Arm *arm = ecs_field(it, Arm, 2);

    for (i32 i = 0; i < it->count; i++) {
        DrawCircle(pos[i].x, pos[i].y, 1.5f, ORANGE);

    }
}

void renderDebugPath(ecs_iter_t *it) {
    Path *path = ecs_field(it, Path, 1);

    for (i32 i = 0; i < it->count; i++) {
        PathData *pathData = path[i].paths;
        bool first = true;
        while (pathData) {
            for (i32 iPath = 0; iPath < pathData->numWaypoints; iPath++) {
                Color color = RED;
                if (first && iPath < path[i].curWaypoint)
                    color = GREEN;
                else if (first && iPath == path[i].curWaypoint)
                    color = ORANGE;
                color.a = 180;

                Position pos = pathData->waypoints[iPath];
                DrawCircle(pos.x, pos.y, 3, color);
            }
            first = false;
            pathData = pathData->next;
        }
    }
}
